-- ============================================================
-- Table: ESO_NATUREZALESAO
-- ============================================================
CREATE TABLE ESO_NATUREZALESAO
(
	NRORG 				NUMBER			NOT NULL,
	NRNATUREZALESAO		NUMBER			NOT NULL,
	DSNATUREZALESAO		VARCHAR2(700)	NOT NULL,
	CDESOCIAL			VARCHAR2(9)		NOT NULL,
	IDATIVO				VARCHAR2(1)		DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_NATLES CHECK (IDATIVO IN ('N','S')),
	DTINCLUSAO			DATE			DEFAULT SYSDATE NOT NULL,
	DTULTATU			DATE			NULL,
	NRORGINCLUSAO		NUMBER(22)		DEFAULT 1 NULL ,
	CDOPERINCLUSAO		VARCHAR2(12)	DEFAULT '1' NULL ,
	NRORGULTATU			NUMBER(22)		DEFAULT 1 NULL ,
	CDOPERULTATU		VARCHAR2(12)	DEFAULT '1' NULL ,
	CONSTRAINT PK_ESO_NATUREZALESAO PRIMARY KEY (NRNATUREZALESAO)
)
/

INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 1, '702000000', 'Lesão imediata')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 2, '702005000', 'Escoriação, abrasão (ferimento superficial)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 3, '702010000', 'Corte, laceração, ferida contusa, punctura (ferida aberta)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 4, '702015000', 'Contusão, esmagamento (superfície cutânea intacta)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 5, '702020000', 'Distensão, torção')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 6, '702025000', 'Inflamação de articulação, tendão ou músculo - inclui sinovite, tenossionovite, etc. Não inclui distensão, torção ou suas consequências')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 7, '702030000', 'Luxação')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 8, '702035000', 'Fratura')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 9, '702040000', 'Queimadura ou escaldadura - efeito de temperatura elevada. Efeito do contato com substância quente. Inclui queimadura por eletricidade, mas não inclui choque elétrico. Não inclui queimadura por substância química, efeito de radiação, queimadura de sol, incapacidade sistêmica como intermação, queimadura por atrito, etc.')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 10, '702042000', 'Queimadura química (lesão de tecido provocada pela ação corrosiva de produto químico, suas emanações, etc.)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 11, '702045000', 'Efeito de radiação (imediato) - queimadura de sol e toda forma de lesão de tecido, osso ou fluido orgânico, por exposição à radiação')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 12, '702048000', 'Congelamento, geladura e outros efeitos da exposição à baixa temperatura')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 13, '702050000', 'Asfixia, estrangulamento, afogamento')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 14, '702055000', 'Intermação, insolação, cãibra, exaustão e outros efeitos da temperatura ambiente elevada - não inclui queimadura de sol ou outros efeitos de radiação')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 15, '702060000', 'Choque elétrico e eletroplessão (eletrocussão)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 16, '702065000', 'Hérnia de qualquer natureza, ruptura')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 17, '702070000', 'Amputação ou enucleação')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 18, '702075000', 'Perda ou diminuição de sentido (audição, visão, olfato, paladar e tato, desde que não seja sequela de outra lesão)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 19, '702080000', 'Concussão cerebral')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 20, '702090000', 'Lesão imediata, NIC')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 21, '704020000', 'Doença contagiosa ou infecciosa (tuberculose, brucelose, etc.)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 22, '704030000', 'Pneumoconiose (silicose, asbestose, etc.)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 23, '704040000', 'Dermatose (erupção, inflamação da pele, inclusive furúnculo, etc.). Geralmente provocada pelo contato direto com substâncias ou agentes sensibilizantes ou irritantes, tais como medicamentos, óleos, agentes biológicos, plantas, madeiras ou metais. Não inclui lesão provocada pela ação corrosiva de produtos químicos, queimadura por contato com substâncias quentes, efeito de exposição à radiação, efeito de exposição a baixas temperaturas ou inflamação ou irritação causada por fricção ou impacto')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 24, '704050000', 'Envenenamento sistêmico - condição mórbida sistêmica provocada por inalação, ingestão ou absorção cutânea de substância tóxica, que afete o metabolismo, o funcionamento do sistema nervoso, do aparelho circulatório, do aparelho digestivo, do aparelho respiratório, dos órgãos de excreção, do sistema músculo-esquelético, etc., inclui ação de produto químico, medicamento, metal ou peçonha. Não inclui efeito de radiação, pneumoconiose, efeito corrosivo de produto químico, irritação cutânea, septicemia ou caso de ferida infectada')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 25, '704060000', 'Perda ou diminuição mediatas de sentido (audição, visão, olfato, paladar e tato, desde que não seja sequela de outra lesão)')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 26, '704070000', 'Efeito de radiação (mediato) - queimadura do sol e toda forma de lesão de tecido, osso, ou fluido orgânico por exposição à radiação.')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 27, '704090000', 'Doença, NIC')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 28, '706050000', 'Lesões múltiplas')
/
INSERT INTO ESO_NATUREZALESAO (NRORG, NRNATUREZALESAO, CDESOCIAL, DSNATUREZALESAO) VALUES (0, 29, '706090000', 'Outras lesões, NIC')
/

-- ============================================================
-- Table: SST_NATUREZA
-- ============================================================
ALTER TABLE SST_NATUREZA ADD NRNATUREZALESAO NUMBER NULL
/

CREATE INDEX FK_308970_FK ON SST_NATUREZA (NRNATUREZALESAO ASC)
/

ALTER TABLE SST_NATUREZA
	ADD CONSTRAINT FK_NATUREZA_NATULESA FOREIGN KEY (NRNATUREZALESAO)
		REFERENCES ESO_NATUREZALESAO (NRNATUREZALESAO)
/