/* Sistemas Integrados TECNISA

Nome: 9809_CDPTRGO_LOG_CDP_ESPEPROD.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela ESPEPROD.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              ESPEPROD, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_ESPEPROD
AFTER DELETE OR INSERT OR UPDATE
ON ESPEPROD FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';  
   V_CONT_LENGTH  := 1;
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :NEW.CDESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:NEW.CDESPEPROD,'') || ' ';
         END IF;
         
         IF :NEW.NMESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'NmEspecificProd= ' || NVL(:NEW.NMESPEPROD,'') || ' ';
         END IF;

         IF :NEW.DTVALESPEPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'DtValnicEspecProd= ' || NVL(TO_CHAR(:NEW.DTVALESPEPRO, 'DD/MM/YYYY'),'') || ' ';
         END IF; 

         IF :NEW.DTINCESPEPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'DtIncluEspecProd= ' || NVL(TO_CHAR(:NEW.DTINCESPEPRO, 'DD/MM/YYYY'),'') || ' ';
         END IF;  

         IF :NEW.QTPADESPEPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'QtPadraoEspecProd= ' || TO_CHAR(:NEW.QTPADESPEPRO) || ' ';
         END IF;  

         IF :NEW.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;  
         
         IF :NEW.CDCIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdCompanhia= ' || :NEW.CDCIA || ' ';
         END IF;

         IF :NEW.CDMANCIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdManualCompanhia=  ' || :NEW.CDMANCIA || ' ';
         END IF; 

         IF :NEW.IDTPMANUAL IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTipoManual= ' || :NEW.IDTPMANUAL || ' ';
         END IF;  

         IF :NEW.IDCOMPPADRAO IS NOT NULL THEN
            V_DESC := V_DESC || 'IdComposicaoReceita= ' || :NEW.IDCOMPPADRAO || ' ';
         END IF;  

         IF :NEW.DTAPRESENTA IS NOT NULL THEN
            V_DESC := V_DESC || 'DtApresentacao= ' || TO_CHAR(:NEW.DTAPRESENTA, 'DD/MM/YYYY') || ' ';
         END IF;  
         
         IF :NEW.NMFOTOESP IS NOT NULL THEN
            V_DESC := V_DESC || 'NomeFoto= ' || :NEW.NMFOTOESP || ' ';
         END IF;

         IF :NEW.DTEFETIVA IS NOT NULL THEN
            V_DESC := V_DESC || 'DtEfetivacaoSub-Grupo= ' || TO_CHAR(:NEW.DTEFETIVA, 'DD/MM/YYYY') || ' ';
         END IF; 

         IF :NEW.DTREVISAO IS NOT NULL THEN
            V_DESC := V_DESC || 'DtRevisao= ' || TO_CHAR(:NEW.DTREVISAO, 'DD/MM/YYYY') || ' ';
         END IF;  

         IF :NEW.CDPRODUTOPRI IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProdutoPri= ' || :NEW.CDPRODUTOPRI || ' ';
         END IF;  

         IF :NEW.DSSUBGRUPO IS NOT NULL THEN
            V_DESC := V_DESC || 'DescricaoSub-Grupo= ' || :NEW.DSSUBGRUPO || ' ' ;
         END IF;          

      V_ITPESQ := :NEW.CDPRODUTO || :NEW.CDESPEPROD;
                  
      V_IDTIPOOPER := '1';  
      V_CDFILLOGOPER := :NEW.CDFILIAL; 

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF (:NEW.CDESPEPROD <> :OLD.CDESPEPROD) THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:NEW.CDESPEPROD,'') || ' ';
         END IF;
         
         IF (:NEW.NMESPEPROD <> :OLD.NMESPEPROD) THEN
            V_DESC := V_DESC || 'NmEspecificProd= ' || NVL(:NEW.NMESPEPROD,'') || ' ';
         END IF;

         IF (:NEW.DTVALESPEPRO <> :OLD.DTVALESPEPRO) THEN
            V_DESC := V_DESC || 'DtValnicEspecProd= ' || NVL(TO_CHAR(:NEW.DTVALESPEPRO, 'DD/MM/YYYY'),'') || ' ';
         END IF; 

         IF (:NEW.DTINCESPEPRO <> :OLD.DTINCESPEPRO) THEN
            V_DESC := V_DESC || 'DtIncluEspecProd= ' || NVL(TO_CHAR(:NEW.DTINCESPEPRO, 'DD/MM/YYYY'),'') || ' ';
         END IF;  

         IF (:NEW.QTPADESPEPRO <> :OLD.QTPADESPEPRO) THEN
            V_DESC := V_DESC || 'QtPadraoEspecProd= ' || TO_CHAR(:NEW.QTPADESPEPRO) || ' ';
         END IF;  

         IF (:NEW.CDOPERADOR <> :OLD.CDOPERADOR) THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;  
         
         IF (:NEW.CDCIA <> :OLD.CDCIA) THEN
            V_DESC := V_DESC || 'CdCompanhia= ' || :NEW.CDCIA || ' ';
         END IF;

         IF (:NEW.CDMANCIA <> :OLD.CDMANCIA) THEN
            V_DESC := V_DESC || 'CdManualCompanhia=  ' || :NEW.CDMANCIA || ' ';
         END IF; 

         IF (:NEW.IDTPMANUAL <> :OLD.IDTPMANUAL) THEN
            V_DESC := V_DESC || 'IdTipoManual= ' || :NEW.IDTPMANUAL || ' ';
         END IF;  

         IF (:NEW.IDCOMPPADRAO <> :OLD.IDCOMPPADRAO) THEN
            V_DESC := V_DESC || 'IdComposicaoReceita= ' || :NEW.IDCOMPPADRAO || ' ';
         END IF;  

         IF (:NEW.DTAPRESENTA <> :OLD.DTAPRESENTA) THEN
            V_DESC := V_DESC || 'DtApresentacao= ' || TO_CHAR(:NEW.DTAPRESENTA, 'DD/MM/YYYY') || ' ';
         END IF;  
         
         IF (:NEW.NMFOTOESP <> :OLD.NMFOTOESP) THEN
            V_DESC := V_DESC || 'NomeFoto= ' || :NEW.NMFOTOESP || ' ';
         END IF;

         IF (:NEW.DTEFETIVA <> :OLD.DTEFETIVA) THEN
            V_DESC := V_DESC || 'DtEfetivacaoSub-Grupo= ' || TO_CHAR(:NEW.DTEFETIVA, 'DD/MM/YYYY') || ' ';
         END IF; 

         IF (:NEW.DTREVISAO <> :OLD.DTREVISAO) THEN
            V_DESC := V_DESC || 'DtRevisao= ' || TO_CHAR(:NEW.DTREVISAO, 'DD/MM/YYYY') || ' ';
         END IF;  

         IF (:NEW.CDPRODUTOPRI <> :OLD.CDPRODUTOPRI) THEN
            V_DESC := V_DESC || 'CdProdutoPri= ' || :NEW.CDPRODUTOPRI || ' ';
         END IF;  

         IF (:NEW.DSSUBGRUPO <> :OLD.DSSUBGRUPO) THEN
            V_DESC := V_DESC || 'DescricaoSub-Grupo= ' || :NEW.DSSUBGRUPO || ' ' ;
         END IF;           

      V_ITPESQ := :NEW.CDPRODUTO || :NEW.CDESPEPROD;

          V_IDTIPOOPER := '2';    
          V_CDFILLOGOPER := :NEW.CDFILIAL; 
          
      END IF; 

   IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :OLD.CDESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:OLD.CDESPEPROD,'') || ' ';
         END IF;
         
         IF :OLD.NMESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'NmEspecificProd= ' || NVL(:OLD.NMESPEPROD,'') || ' ';
         END IF;

         IF :OLD.DTVALESPEPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'DtValnicEspecProd= ' || NVL(TO_CHAR(:OLD.DTVALESPEPRO, 'DD/MM/YYYY'),'') || ' ';
         END IF; 

         IF :OLD.DTINCESPEPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'DtIncluEspecProd= ' || NVL(TO_CHAR(:OLD.DTINCESPEPRO, 'DD/MM/YYYY'),'') || ' ';
         END IF;  

         IF :OLD.QTPADESPEPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'QtPadraoEspecProd= ' || TO_CHAR(:OLD.QTPADESPEPRO) || ' ';
         END IF;  

         IF :OLD.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:OLD.CDOPERADOR,'') || ' ';
         END IF;  
         
         IF :OLD.CDCIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdCompanhia= ' || :OLD.CDCIA || ' ';
         END IF;

         IF :OLD.CDMANCIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdManualCompanhia=  ' || :OLD.CDMANCIA || ' ';
         END IF; 

         IF :OLD.IDTPMANUAL IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTipoManual= ' || :OLD.IDTPMANUAL || ' ';
         END IF;  

         IF :OLD.IDCOMPPADRAO IS NOT NULL THEN
            V_DESC := V_DESC || 'IdComposicaoReceita= ' || :OLD.IDCOMPPADRAO || ' ';
         END IF;  

         IF :OLD.DTAPRESENTA IS NOT NULL THEN
            V_DESC := V_DESC || 'DtApresentacao= ' || TO_CHAR(:OLD.DTAPRESENTA, 'DD/MM/YYYY') || ' ';
         END IF;  
         
         IF :OLD.NMFOTOESP IS NOT NULL THEN
            V_DESC := V_DESC || 'NomeFoto= ' || :OLD.NMFOTOESP || ' ';
         END IF;

         IF :OLD.DTEFETIVA IS NOT NULL THEN
            V_DESC := V_DESC || 'DtEfetivacaoSub-Grupo= ' || TO_CHAR(:OLD.DTEFETIVA, 'DD/MM/YYYY') || ' ';
         END IF; 

         IF :OLD.DTREVISAO IS NOT NULL THEN
            V_DESC := V_DESC || 'DtRevisao= ' || TO_CHAR(:OLD.DTREVISAO, 'DD/MM/YYYY') || ' ';
         END IF;  

         IF :OLD.CDPRODUTOPRI IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProdutoPri= ' || :OLD.CDPRODUTOPRI || ' ';
         END IF;  

         IF :OLD.DSSUBGRUPO IS NOT NULL THEN
            V_DESC := V_DESC || 'DescricaoSub-Grupo= ' || :OLD.DSSUBGRUPO || ' ' ;
         END IF;          
         
      V_ITPESQ := :OLD.CDPRODUTO || :OLD.CDESPEPROD;

      V_IDTIPOOPER := '3';
      V_CDFILLOGOPER := :OLD.CDFILIAL;

   END IF;   

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                      VALUES  ('ESPEPROD', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC, V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER); 
  
      END LOOP;       
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_ESPEPROD','5.07.001'); END;
/    
