/*************************************************************************************************/
/*                                                                                               */
/* Trigger: DTULTATU_QUALIFICASS                                                                 */
/* Tabela : QUALIFASSINANTE                                                                      */
/*                                                                                               */
/* Criao:                                                                                      */
/* 17/08/2010 - ANDR FELIPE CAMPOS HIBENE                                                       */
/*                                                                                               */
/*************************************************************************************************/

IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DTULTATU_QUALIFICASS'
             AND TYPE   = 'TR'
             AND U.UID  = O.UID
             AND U.NAME = USER)
   DROP TRIGGER DTULTATU_QUALIFICASS
GO

CREATE TRIGGER DTULTATU_QUALIFICASS
ON QUALIFASSINANTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'QUALIFASSINANTE', 'CDQUALIFASSINA=' + CDQUALIFASSINA + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE QUALIFASSINANTE
         SET DTULTATU = GETDATE()
        FROM INSERTED
       WHERE ISNULL(QUALIFASSINANTE.CDQUALIFASSINA, 0) = ISNULL(INSERTED.CDQUALIFASSINA, 0);
   END;
END;
GO