/* Procedure para incluso da NF referente ao financeiro */
IF EXISTS (SELECT * FROM sysobjects O, sysusers U
           WHERE
            o.name = 'INCLUI_NOTA'  and
            type = 'P'                        and
            u.uid = o.uid                     and
            u.name = USER)

   DROP PROCEDURE INCLUI_NOTA;
GO

CREATE PROCEDURE INCLUI_NOTA(
   @P_IDENTRSAIDOP  VARCHAR(1),
   @P_CDEMPRESA     VARCHAR(2),
   @P_CDINSCESTA    VARCHAR(16),
   @P_CDINSCMUNI    VARCHAR(16),
   @P_CDFILIAL      VARCHAR(4),
   @P_LANCAMENTO    VARCHAR(10),
   @P_CDFILRECEMI   VARCHAR(30),
   @P_VALORDOC      CHAR(10),
   @P_TIPOOPER      VARCHAR(2),
   @P_IDORIGDEST    VARCHAR(1),
   @P_CDCLIEFORN    VARCHAR(21),
   @P_NRNOTAFISC    VARCHAR(20),
   @P_CDSERIE       VARCHAR(5),
   @P_DTEMISSAO     DATETIME,
   @P_DTENTRSAID    DATETIME,
   @P_LINCENUSO     VARCHAR(10),
   @P_CDVENDEDOR    VARCHAR(4),
   @P_CDDESPESA     VARCHAR(10),
   @P_STATUS        VARCHAR(1),
   @P_DTLANCNF      DATETIME)
AS
   DECLARE @V_IDTPIJUR VARCHAR(1);
   DECLARE @V_NRINSJUR VARCHAR(20);
BEGIN
   IF @P_IDORIGDEST = 'F' BEGIN
      /* SE A ORIGEM FOR FORNECEDOR*/

         SELECT  @V_IDTPIJUR = IDTPIJURFORN,
                 @V_NRINSJUR = NRINSJURFORN
         FROM    FORNECEDOR
         WHERE   CDFORNECED = @P_CDCLIEFORN;
   END

   ELSE IF @P_IDORIGDEST = 'C' BEGIN
      /*SE A ORIGEM FOR CLIENTE*/

            SELECT @V_IDTPIJUR = IDTPIJURCLIE,
                   @V_NRINSJUR = NRINSJURCLIE
            FROM   CLIENTE
            WHERE  CDCLIENTE   = @P_CDCLIEFORN;


   END
   ELSE IF @P_IDORIGDEST = 'L' BEGIN
      /*SE A ORIGEM FOR FILIAL*/

               SELECT @V_IDTPIJUR = IDTPIJURFILI,
                      @V_NRINSJUR = NRINSJURFILI
               FROM   FILIAL
               WHERE  CDFILIAL = @P_CDFILRECEMI;


   END;

   IF @P_IDENTRSAIDOP = 'E' BEGIN
      INSERT INTO NOTAFISCAL
         (CDFILIAL,   NRLANCTONF,  CDEMPRESA,   CDINSCESTA,  CDINSCMUNI,  CDFILIRECE,
          IDTPIJURNF, NRINSJURNF,  CDFORNECED,  IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
          VRPRODUTOS, VRNOTAFISC,  NRNOTAFISC,  DTEMISSAO,   DTENTRSAID,  IDENTRSAIDOP,
          CDTIPOOPER, CDSERIEENTR, IDDOCCONTAB, IDSTATUS,    IDSISTEMA,   CDAUTDESPESA, DTLANCAMENNF)
      VALUES
         (@P_CDFILIAL,   @P_LANCAMENTO,   @P_CDEMPRESA,   @P_CDINSCESTA, @P_CDINSCMUNI, @P_CDFILRECEMI,
          @V_IDTPIJUR,   @V_NRINSJUR,     @P_CDCLIEFORN, 'S', 'N', 'S',  @P_VALORDOC,   @P_VALORDOC,
          @P_NRNOTAFISC, @P_DTEMISSAO,    @P_DTENTRSAID, 'E',            @P_TIPOOPER,   @P_CDSERIE, 'S',
          @P_STATUS,     'PDV',           @P_CDDESPESA,   @P_DTLANCNF);

   END
   ELSE BEGIN

      INSERT INTO NOTAFISCAL
        (CDFILIAL,     NRLANCTONF,   CDEMPRESA,   CDINSCESTA,   CDINSCMUNI,  CDFILIEMIT,
         IDTPIJURNF,   NRINSJURNF,   CDCLIENTE,   IDBLOQUEADO,  IDDOCFISCAL, IDDOCFINANC,
         VRPRODUTOS,   VRNOTAFISC,   NRNOTAFISC,  DTEMISSAO,    DTENTRSAID,  IDENTRSAIDOP,
         CDTIPOOPER,   CDSERIE,      IDDOCCONTAB, IDSTATUS,     IDDOCFISCENT,
         IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,   NRLICENCAUSO, CDVENDEDOR,  DTLANCAMENNF)
      VALUES
        (@P_CDFILIAL, @P_LANCAMENTO, @P_CDEMPRESA,  @P_CDINSCESTA, @P_CDINSCMUNI, @P_CDFILRECEMI,
         @V_IDTPIJUR, @V_NRINSJUR,   @P_CDCLIEFORN, 'S', 'N', 'S',
         @P_VALORDOC, @P_VALORDOC,   @P_NRNOTAFISC, @P_DTEMISSAO,  @P_DTENTRSAID, 'S',
         @P_TIPOOPER, @P_CDSERIE,    'S',           @P_STATUS,     'N',
         'S', 'N',    'PDV',         NULL,  @P_CDVENDEDOR,  @P_DTLANCNF);
   END;
END;


-- VERSAO --
EXEC ATUVEROBJ 'INCLUI_NOTA','5.11.000';
GO

